PROGRAM differ;
{ find the difference between file1 and file2 and write result to file3 }
{ will find all text that is in file2 but not in file1 }
{ note that file2 has to include all text of file1 (use MergeRead in the }
{ Dictionary Manager) and both files are sorted in the same manner }

USES Crt;

VAR f1, f2, f3: Text;
    s1, s2: string;

FUNCTION Zeilelesen(VAR f: Text): string;
{ this can handle unix-style files }
{ reading the file character by character makes this very slow }
{ if you only have dos-style files you should use Readln(f,s) instead }
{ one could also make use of BlockRead procedure ... }

VAR c: char;
    s: string;

BEGIN
  REPEAT
    s:='';
    REPEAT
      Read(f,c);
      If NOT(c IN [#10,#13]) Then s:=s+c;
    UNTIL (c = #10);
  UNTIL (EOF(f) OR (s[1] <> '%'));
  Zeilelesen:=s;
END;

BEGIN
  ClrScr;
  Assign(f1,'small.dic');
  Assign(f2,'big.dic');
  Assign(f3,'diff.dic');
  Reset(f1);
  Reset(f2);
  Rewrite(f3);
  WHILE NOT EOF(f1) Do
  BEGIN
    s1:=Zeilelesen(f1);
    REPEAT
      s2:=Zeilelesen(f2);
      If (s1 <> s2) Then
      BEGIN
        writeln(f3,s2);
      END;
      If (EOF(f2) AND NOT(EOF(f1))) Then
      BEGIN
        Writeln('Problems encountered.'#7);
        Close(f1);
        Close(f2);
        Close(f3);
        HALT;
      END;
    UNTIL (s1 = s2);
  END;
  WHILE NOT EOF(f2) Do
  BEGIN
    s2:=Zeilelesen(f2);
    writeln(f3,s2);
  END;
  Close(f1);
  Close(f2);
  Close(f3);
  Writeln('The End')
END.